using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;

namespace GGC_ABC
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.button3 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.button1 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(40, 40);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(512, 400);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "3.301.0.0";
			// 
			// button3
			// 
			this.button3.Location = new System.Drawing.Point(288, 8);
			this.button3.Name = "button3";
			this.button3.TabIndex = 3;
			this.button3.Text = "AddTo C";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(184, 8);
			this.button2.Name = "button2";
			this.button2.TabIndex = 2;
			this.button2.Text = "AddTo B";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(80, 8);
			this.button1.Name = "button1";
			this.button1.TabIndex = 1;
			this.button1.Text = "AddTo A";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(592, 462);
			this.Controls.Add(this.button3);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		DataTable dtA;
		DataTable dtB;
		DataTable dtC;
		private void Form1_Load(object sender, System.EventArgs e)
		{
			dtA = new DataTable("A");
			dtA.Columns.Add("idA", typeof(int));
			dtA.Columns.Add("Data");

			dtB = new DataTable("B");
			dtB.Columns.Add("idA", typeof(int));
			dtB.Columns.Add("idB", typeof(int));
			dtB.Columns.Add("Data");

			dtC = new DataTable("C");
			dtC.Columns.Add("idA", typeof(int));
			dtC.Columns.Add("idB", typeof(int));
			dtC.Columns.Add("idC", typeof(int));
			dtC.Columns.Add("Data");

			//this.button1.PerformClick(); //add 1 row to A
			//this.button2.PerformClick(); //add 1 row to B
			//this.button3.PerformClick(); //add 1 row to C

			DataSet ds = new DataSet();
			ds.Tables.AddRange(new DataTable[]{dtA, dtB, dtC});

			DataRelation drAB = new DataRelation("AB", dtA.Columns["idA"], dtB.Columns["idA"]);
			DataRelation drBC = new DataRelation("BC",
				new DataColumn[]{dtB.Columns["idA"], dtB.Columns["idB"]},
				new DataColumn[]{dtC.Columns["idA"], dtC.Columns["idB"]});
			DataRelation drAC = new DataRelation("AC", dtA.Columns["idA"], dtC.Columns["idA"]);
			
			ds.Relations.AddRange(new DataRelation[]{drAB, drBC, drAC});

			InitGroupingGrid(this.gridGroupingControl1, ds, dtA);
		}

		#region init grouping grid
		public static int DefaultRowHeight = 16;
		public static Color[] LightColors = new Color[]{ Color.LightBlue, Color.Wheat, Color.Honeydew };

		public static void InitGroupingGrid(GridGroupingControl g, bool gridreadonly)
		{
			g.TableOptions.AllowDragColumns = false;
			g.TableOptions.AllowDropDownCell = false;
			g.TableOptions.ColumnHeaderRowHeight = DefaultRowHeight;
			g.TableOptions.RecordRowHeight = DefaultRowHeight;
			g.TableOptions.ShowRowHeader = false;

			g.TopLevelGroupOptions.ShowCaption = false;
			g.TopLevelGroupOptions.ShowSummaries = false;

			g.ChildGroupOptions.ShowCaption = false;
			g.ChildGroupOptions.ShowSummaries = false;

			g.NestedTableGroupOptions.ShowCaption = false;
			g.NestedTableGroupOptions.ShowSummaries = false;

			if (gridreadonly)
				SetTableDescriptorReadOnly(g.TableDescriptor, 0);
		}

		private static void SetTableDescriptorReadOnly(GridTableDescriptor d, int ci)
		{
			d.AllowEdit = false;
			d.AllowNew = false;
			d.AllowRemove = false;
			d.Appearance.RecordFieldCell.BackColor = LightColors[ci];
			d.Appearance.AlternateRecordFieldCell.BackColor = LightColors[ci];

			foreach (GridRelationDescriptor rd in d.Relations)
			{
				if (ci + 1 < LightColors.Length) ++ci;
				SetTableDescriptorReadOnly(rd.ChildTableDescriptor, ci);
			}
		}

		public static void InitGroupingGrid(GridGroupingControl g, DataSet dataset, DataTable table)
		{
			InitGroupingGrid(g, dataset, table, true);
		}

		public static void InitGroupingGrid(GridGroupingControl g, DataSet dataset, DataTable table,
			bool gridreadonly)
		{
			g.DataMember = table.TableName;
			g.DataSource = dataset;

			InitGroupingGrid(g, gridreadonly);
		}
		#endregion

		int a = 0;
		int b = 0;
		int c = 0;
		private void button1_Click(object sender, System.EventArgs e)
		{
			++a;
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			++b;
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			DataRow dr;
			if (dtA.Select("idA = " + a.ToString()).Length == 0)
			{
				dr = dtA.NewRow();
				dr[0] = (a).ToString();
				dr[1] = "AAAA";
				dtA.Rows.Add(dr);
			}

			if (dtB.Select("idA = " + a.ToString() + " and idB = " + b.ToString()).Length == 0)
			{
				dr = dtB.NewRow();
				dr[0] = (a).ToString();
				dr[1] = (b).ToString();
				dr[2] = "BBBB";
				dtB.Rows.Add(dr);
			}

			dr = dtC.NewRow();
			dr[0] = (a).ToString();
			dr[1] = (b).ToString();
			dr[2] = (c++).ToString();
			dr[3] = "CCCC";
			dtC.Rows.Add(dr);
		}
	}
}
